xref: /xnu-8020.140.41/tools/remote_build.sh (revision 27b03b360a988dfd3dfdf34262bb0042026747cc)
1*27b03b36SApple OSS Distributions#!/bin/bash
2*27b03b36SApple OSS Distributions#
3*27b03b36SApple OSS Distributions# Script that rsyncs a source/build tree to a remote server, performs a build,
4*27b03b36SApple OSS Distributions# and copies the result back
5*27b03b36SApple OSS Distributions#
6*27b03b36SApple OSS Distributions
7*27b03b36SApple OSS Distributions# This script is invoked instead of the initial recursive make(1) in ./Makefile.
8*27b03b36SApple OSS Distributions# First it must cache all binaries that might be used during the build by
9*27b03b36SApple OSS Distributions# calling "make print_exports" (any target would work) with an overriden xcrun(1)
10*27b03b36SApple OSS Distributions# which caches tools an SDKs into ./BUILD/obj/BuildTools. When the combined
11*27b03b36SApple OSS Distributions# source+build tree is rsync-ed to the remote server, we run a script to
12*27b03b36SApple OSS Distributions# re-initiate the build using an overriden xcrun(1) which hands back
13*27b03b36SApple OSS Distributions# cached tools in ./BUILD/obj/BuildTools instead of whatever Xcode tools are on
14*27b03b36SApple OSS Distributions# the remote system (or if no Xcode tools are installed remotely). Finally,
15*27b03b36SApple OSS Distributions# the build results are copied back locally.
16*27b03b36SApple OSS Distributions#
17*27b03b36SApple OSS Distributions
18*27b03b36SApple OSS Distributionsfunction die() {
19*27b03b36SApple OSS Distributions    echo "$1" 1>&2
20*27b03b36SApple OSS Distributions    exit 1
21*27b03b36SApple OSS Distributions}
22*27b03b36SApple OSS Distributions
23*27b03b36SApple OSS Distributions
24*27b03b36SApple OSS DistributionsTARGET=
25*27b03b36SApple OSS Distributionsdeclare -a ARGS
26*27b03b36SApple OSS Distributionsdeclare -a REMOTEARGS
27*27b03b36SApple OSS Distributionsindex=0
28*27b03b36SApple OSS Distributionsfor arg in "$@"; do
29*27b03b36SApple OSS Distributions    case $arg in
30*27b03b36SApple OSS Distributions	_REMOTEBUILD_TARGET=*)
31*27b03b36SApple OSS Distributions	    TARGET=`echo $arg | awk -F= '{print $2}'`
32*27b03b36SApple OSS Distributions	    continue
33*27b03b36SApple OSS Distributions	    ;;
34*27b03b36SApple OSS Distributions	_REMOTEBUILD_MAKE=*)
35*27b03b36SApple OSS Distributions	    MAKE=`echo $arg | awk -F= '{print $2}'`
36*27b03b36SApple OSS Distributions	    continue
37*27b03b36SApple OSS Distributions	    ;;
38*27b03b36SApple OSS Distributions	REMOTEBUILD=*)
39*27b03b36SApple OSS Distributions	    # Don't restart another remote build remotely
40*27b03b36SApple OSS Distributions	    ;;
41*27b03b36SApple OSS Distributions	SRCROOT=*)
42*27b03b36SApple OSS Distributions	    continue
43*27b03b36SApple OSS Distributions	    ;;
44*27b03b36SApple OSS Distributions	OBJROOT=*)
45*27b03b36SApple OSS Distributions	    continue
46*27b03b36SApple OSS Distributions	    ;;
47*27b03b36SApple OSS Distributions	SYMROOT=*)
48*27b03b36SApple OSS Distributions	    continue
49*27b03b36SApple OSS Distributions	    ;;
50*27b03b36SApple OSS Distributions	DSTROOT=*)
51*27b03b36SApple OSS Distributions	    continue
52*27b03b36SApple OSS Distributions	    ;;
53*27b03b36SApple OSS Distributions	CCHROOT=*)
54*27b03b36SApple OSS Distributions	    continue
55*27b03b36SApple OSS Distributions	    ;;
56*27b03b36SApple OSS Distributions	RC_XBS=*)
57*27b03b36SApple OSS Distributions	    # Remote build isn't chrooted or special in any way
58*27b03b36SApple OSS Distributions	    arg="VERBOSE=YES"
59*27b03b36SApple OSS Distributions	    continue
60*27b03b36SApple OSS Distributions	    ;;
61*27b03b36SApple OSS Distributions	VERBOSE=YES)
62*27b03b36SApple OSS Distributions	    set -x
63*27b03b36SApple OSS Distributions	    ;;
64*27b03b36SApple OSS Distributions    esac
65*27b03b36SApple OSS Distributions    ARGS[$index]="$arg"
66*27b03b36SApple OSS Distributions    REMOTEARGS[$index]="\"$arg\""
67*27b03b36SApple OSS Distributions    index=$(($index+1))
68*27b03b36SApple OSS Distributionsdone
69*27b03b36SApple OSS Distributions
70*27b03b36SApple OSS Distributions
71*27b03b36SApple OSS DistributionsRSYNC_ARGS="-azvh"
72*27b03b36SApple OSS DistributionsARGS[$index]="REMOTEBUILD="
73*27b03b36SApple OSS DistributionsREMOTEARGS[$index]="\"REMOTEBUILD=\""
74*27b03b36SApple OSS Distributions
75*27b03b36SApple OSS Distributions# For some targets like installsrc, we can't to a remote build
76*27b03b36SApple OSS DistributionsSKIPREMOTE=0
77*27b03b36SApple OSS Distributionscase $TARGET in
78*27b03b36SApple OSS Distributions    clean)
79*27b03b36SApple OSS Distributions	SKIPREMOTE=1
80*27b03b36SApple OSS Distributions	;;
81*27b03b36SApple OSS Distributions    installsrc)
82*27b03b36SApple OSS Distributions	SKIPREMOTE=1
83*27b03b36SApple OSS Distributions	;;
84*27b03b36SApple OSS Distributions    installopensource)
85*27b03b36SApple OSS Distributions	SKIPREMOTE=1
86*27b03b36SApple OSS Distributions	;;
87*27b03b36SApple OSS Distributions    cscope)
88*27b03b36SApple OSS Distributions	SKIPREMOTE=1
89*27b03b36SApple OSS Distributions	;;
90*27b03b36SApple OSS Distributions    tags)
91*27b03b36SApple OSS Distributions	SKIPREMOTE=1
92*27b03b36SApple OSS Distributions	;;
93*27b03b36SApple OSS Distributions    help)
94*27b03b36SApple OSS Distributions	SKIPREMOTE=1
95*27b03b36SApple OSS Distributions	;;
96*27b03b36SApple OSS Distributionsesac
97*27b03b36SApple OSS Distributions
98*27b03b36SApple OSS Distributionsif [ $SKIPREMOTE -eq 1 ]; then
99*27b03b36SApple OSS Distributions    exec "$MAKE" "$TARGET" "${ARGS[@]}"
100*27b03b36SApple OSS Distributionsfi
101*27b03b36SApple OSS Distributions
102*27b03b36SApple OSS DistributionsSRC="$(pwd -P)"
103*27b03b36SApple OSS DistributionsSRCNAME="$(basename $SRC)"
104*27b03b36SApple OSS Distributions
105*27b03b36SApple OSS Distributions# Pick up build locations passed in the environment
106*27b03b36SApple OSS DistributionsOBJROOT="${OBJROOT}"
107*27b03b36SApple OSS DistributionsSYMROOT="${SYMROOT}"
108*27b03b36SApple OSS DistributionsDSTROOT="${DSTROOT}"
109*27b03b36SApple OSS Distributions
110*27b03b36SApple OSS Distributionsif [ -z "${OBJROOT}" ]; then
111*27b03b36SApple OSS Distributions    die "OBJROOT not set in environment"
112*27b03b36SApple OSS Distributionsfi
113*27b03b36SApple OSS Distributionsmkdir -p "${OBJROOT}" || die "Could not create ${OBJROOT}"
114*27b03b36SApple OSS Distributions
115*27b03b36SApple OSS Distributionsif [ -z "${SYMROOT}" ]; then
116*27b03b36SApple OSS Distributions    die "SYMROOT not set in environment"
117*27b03b36SApple OSS Distributionsfi
118*27b03b36SApple OSS Distributionsmkdir -p "${SYMROOT}" || die "Could not create ${SYMROOT}"
119*27b03b36SApple OSS Distributions
120*27b03b36SApple OSS Distributionsif [ -z "${DSTROOT}" ]; then
121*27b03b36SApple OSS Distributions    die "DSTROOT not set in environment"
122*27b03b36SApple OSS Distributionsfi
123*27b03b36SApple OSS Distributionsmkdir -p "${DSTROOT}" || die "Could not create ${DSTROOT}"
124*27b03b36SApple OSS Distributions
125*27b03b36SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
126*27b03b36SApple OSS Distributions    :
127*27b03b36SApple OSS Distributionselse
128*27b03b36SApple OSS Distributions    DOINSTALLSRC=0
129*27b03b36SApple OSS Distributions    REMOTE_SRCREL="./"
130*27b03b36SApple OSS Distributions    BUILDTOOLSDIR="$OBJROOT"
131*27b03b36SApple OSS Distributions    REMOTE_BUILDTOOLSREL="./BUILD/obj"
132*27b03b36SApple OSS Distributions    BUILDSCRIPTDIR="$OBJROOT"
133*27b03b36SApple OSS Distributions    REMOTE_BUILDSCRIPTREL="./BUILD/obj"
134*27b03b36SApple OSS Distributions    BUILDSCRIPTNAME="build.sh"
135*27b03b36SApple OSS Distributions    if [ ! -d "${OBJROOT}/SETUP" ]; then
136*27b03b36SApple OSS Distributions    RSYNC_DELETE_EXCLUDED="--delete-excluded"
137*27b03b36SApple OSS Distributions    else
138*27b03b36SApple OSS Distributions    RSYNC_DELETE_EXCLUDED=""
139*27b03b36SApple OSS Distributions    fi
140*27b03b36SApple OSS Distributions    if [ ! -e "${SYMROOT}/" ]; then
141*27b03b36SApple OSS Distributions	RSYNC_DELETE_SYMROOT=1
142*27b03b36SApple OSS Distributions    else
143*27b03b36SApple OSS Distributions	RSYNC_DELETE_SYMROOT=0
144*27b03b36SApple OSS Distributions    fi
145*27b03b36SApple OSS Distributions    if [ ! -e "${DSTROOT}/" ]; then
146*27b03b36SApple OSS Distributions	RSYNC_DELETE_DSTROOT=1
147*27b03b36SApple OSS Distributions    else
148*27b03b36SApple OSS Distributions	RSYNC_DELETE_DSTROOT=0
149*27b03b36SApple OSS Distributions    fi
150*27b03b36SApple OSS Distributions    TARBUILDDIRS=0
151*27b03b36SApple OSS Distributionsfi
152*27b03b36SApple OSS Distributions
153*27b03b36SApple OSS Distributionsecho "Caching build tools..." 1>&2
154*27b03b36SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}" || die "Could not create BUILDTOOLSDIR"
155*27b03b36SApple OSS Distributions$MAKE print_exports "${ARGS[@]}" XCRUN="${SRC}/tools/xcrun_cache.sh -c \"${BUILDTOOLSDIR}\"" >/dev/null || die "Could not cache build tools"
156*27b03b36SApple OSS Distributions
157*27b03b36SApple OSS Distributions# Cache the make(1) binary itself
158*27b03b36SApple OSS DistributionsMAKE_SDKROOT=`"${SRC}/tools/xcrun_cache.sh" -u "${BUILDTOOLSDIR}" -sdk / -show-sdk-path`
159*27b03b36SApple OSS Distributions"${SRC}/tools/xcrun_cache.sh" -c "${BUILDTOOLSDIR}" -sdk "${MAKE_SDKROOT}" -find make >/dev/null || die "Could not cache make"
160*27b03b36SApple OSS Distributions
161*27b03b36SApple OSS Distributions# Create a canned build script that can restart the build on the remote server.
162*27b03b36SApple OSS Distributionsmkdir -p "${BUILDSCRIPTDIR}" || die "Could not create BUILDSCRIPTDIR"
163*27b03b36SApple OSS Distributionscat > "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}" <<EOF
164*27b03b36SApple OSS Distributions#!/bin/sh
165*27b03b36SApple OSS Distributionsmkdir -p /private/tmp
166*27b03b36SApple OSS Distributionsmkdir -p /private/var/tmp
167*27b03b36SApple OSS Distributionsmkdir -p "\${TMPDIR}"
168*27b03b36SApple OSS Distributionscd "${REMOTE_SRCREL}"
169*27b03b36SApple OSS Distributionsmkdir -p ./BUILD/obj
170*27b03b36SApple OSS Distributionsmkdir -p ./BUILD/sym
171*27b03b36SApple OSS Distributionsmkdir -p ./BUILD/dst
172*27b03b36SApple OSS DistributionsMAKE=\`\$PWD/tools/xcrun_cache.sh -u "\$PWD/${REMOTE_BUILDTOOLSREL}" -sdk / -find make\`
173*27b03b36SApple OSS Distributionsif [ -z "\${MAKE}" ]; then exit 1; fi
174*27b03b36SApple OSS Distributions\${MAKE} ${TARGET} ${REMOTEARGS[@]} XCRUN="\$PWD/tools/xcrun_cache.sh -u \"\$PWD/${REMOTE_BUILDTOOLSREL}\""
175*27b03b36SApple OSS Distributionsret=\$?
176*27b03b36SApple OSS Distributionsif [ \$ret -eq 0 ]; then
177*27b03b36SApple OSS Distributionsif [ ${TARBUILDDIRS} -eq 1 ]; then
178*27b03b36SApple OSS Distributionstar jcf ./BUILD/obj.tar.bz2 --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf --exclude=conf -C ./BUILD/obj . || exit 1
179*27b03b36SApple OSS Distributionstar jcf ./BUILD/sym.tar.bz2 -C ./BUILD/sym . || exit 1
180*27b03b36SApple OSS Distributionstar jcf ./BUILD/dst.tar.bz2 -C ./BUILD/dst . || exit 1
181*27b03b36SApple OSS Distributionsfi
182*27b03b36SApple OSS Distributionsfi
183*27b03b36SApple OSS Distributionsexit \$ret
184*27b03b36SApple OSS DistributionsEOF
185*27b03b36SApple OSS Distributionschmod a+x "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
186*27b03b36SApple OSS Distributions#echo "Build script is:"
187*27b03b36SApple OSS Distributions#cat "${BUILDSCRIPTDIR}/${BUILDSCRIPTNAME}"
188*27b03b36SApple OSS Distributions
189*27b03b36SApple OSS Distributionsmkdir -p "${BUILDTOOLSDIR}/empty"
190*27b03b36SApple OSS Distributions
191*27b03b36SApple OSS Distributionsif [ "$REMOTEBUILD" = "$SPECIALREMOTEBUILD" ]; then
192*27b03b36SApple OSS Distributions    :
193*27b03b36SApple OSS Distributionselse
194*27b03b36SApple OSS Distributions
195*27b03b36SApple OSS Distributions    REMOTEBUILD="$REMOTEBUILD"
196*27b03b36SApple OSS Distributions    REMOTEBUILDPATH="$REMOTEBUILDPATH"
197*27b03b36SApple OSS Distributions
198*27b03b36SApple OSS Distributions    if [ -z "$REMOTEBUILDPATH" ]; then
199*27b03b36SApple OSS Distributions	WHOAMI=`whoami`
200*27b03b36SApple OSS Distributions	case "${REMOTEBUILD}" in
201*27b03b36SApple OSS Distributions	    *@*)
202*27b03b36SApple OSS Distributions		WHOAMI=`echo "${REMOTEBUILD}" | awk -F@ '{print $1}'`
203*27b03b36SApple OSS Distributions		;;
204*27b03b36SApple OSS Distributions	esac
205*27b03b36SApple OSS Distributions	REMOTEBUILDPATH="/tmp/$WHOAMI"
206*27b03b36SApple OSS Distributions    fi
207*27b03b36SApple OSS Distributions
208*27b03b36SApple OSS Distributions# Construct a unique remote path
209*27b03b36SApple OSS Distributions    eval `stat -s "${SRC}"`
210*27b03b36SApple OSS Distributions
211*27b03b36SApple OSS Distributions    REMOTEBUILDPATH="${REMOTEBUILDPATH}/$st_ino/${SRCNAME}/"
212*27b03b36SApple OSS Distributions    echo "Remote path is ${REMOTEBUILD}:${REMOTEBUILDPATH}" 1>&2
213*27b03b36SApple OSS Distributions
214*27b03b36SApple OSS Distributions    ssh $REMOTEBUILD "mkdir -p \"${REMOTEBUILDPATH}/BUILD/\"{obj,sym,dst}" || die "Could not make remote build directory"
215*27b03b36SApple OSS Distributions
216*27b03b36SApple OSS Distributions    # Copy source only
217*27b03b36SApple OSS Distributions    rsync $RSYNC_ARGS --delete --exclude=\*~ --exclude=.svn --exclude=.git --exclude=/BUILD . $REMOTEBUILD:"${REMOTEBUILDPATH}" || die "Could not rsync source tree"
218*27b03b36SApple OSS Distributions
219*27b03b36SApple OSS Distributions    # Copy partial OBJROOT (just build tools and build script), and optionally delete everything else
220*27b03b36SApple OSS Distributions    rsync $RSYNC_ARGS --delete $RSYNC_DELETE_EXCLUDED --include=/build.sh --include=/BuildTools --include=/BuildTools/\*\* --exclude=\* "${OBJROOT}/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" || die "Could not rsync build tree"
221*27b03b36SApple OSS Distributions
222*27b03b36SApple OSS Distributions    # Delete remote SYMROOT if it has been deleted locally
223*27b03b36SApple OSS Distributions    if [ "$RSYNC_DELETE_SYMROOT" -eq 1 ]; then
224*27b03b36SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" || die "Could not rsync delete SYMROOT"
225*27b03b36SApple OSS Distributions    fi
226*27b03b36SApple OSS Distributions
227*27b03b36SApple OSS Distributions    # Delete remote DSTROOT if it has been deleted locally
228*27b03b36SApple OSS Distributions    if [ "$RSYNC_DELETE_DSTROOT" -eq 1 ]; then
229*27b03b36SApple OSS Distributions	rsync $RSYNC_ARGS --delete "${BUILDTOOLSDIR}/empty/" $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" || die "Could not rsync delete DSTROOT"
230*27b03b36SApple OSS Distributions    fi
231*27b03b36SApple OSS Distributions
232*27b03b36SApple OSS Distributions    # Start the build
233*27b03b36SApple OSS Distributions    echo ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" 1>&2
234*27b03b36SApple OSS Distributions    ssh $REMOTEBUILD "/bin/bash -c 'cd \"${REMOTEBUILDPATH}\" && ${REMOTE_BUILDSCRIPTREL}/${BUILDSCRIPTNAME}'" || die "Could not complete remote build"
235*27b03b36SApple OSS Distributions
236*27b03b36SApple OSS Distributions    # Copy back build results except for object files (which might be several GB)
237*27b03b36SApple OSS Distributions    echo "Copying results back..."
238*27b03b36SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g --exclude=\*.o --exclude=\*.cpo --exclude=\*.d --exclude=\*.cpd --exclude=\*.non_lto --exclude=\*.ctf $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/obj/" "${OBJROOT}/" || die "Could not rsync build results"
239*27b03b36SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/sym/" "${SYMROOT}/" || die "Could not rsync build results"
240*27b03b36SApple OSS Distributions    rsync $RSYNC_ARGS --no-o --no-g $REMOTEBUILD:"${REMOTEBUILDPATH}/BUILD/dst/" "${DSTROOT}/" || die "Could not rsync build results"
241*27b03b36SApple OSS Distributions
242*27b03b36SApple OSS Distributionsfi
243*27b03b36SApple OSS Distributions
244*27b03b36SApple OSS Distributionsexit 0
245